import { Component, Input } from '@angular/core';
import { DetailsService } from 'src/services/details/details.service';

@Component({
  selector: 'app-status-details',
  templateUrl: './status-details.component.html',
  styleUrl: './status-details.component.scss',
})
export class StatusDetailsComponent {
  public constructor(public detailsAccessor: DetailsService) {}

  @Input() public conditions: string[] = [];
  public currentCondition: string = '';

  public conditionOptions: string[] = [
    'Betäubt',
    'Bewusstlos',
    'Bezaubert',
    'Blind',
    'Festgesetzt',
    'Gelähmt',
    'Gepackt',
    'Kampfunfähig',
    'Liegend',
    'Taub',
    'Unsichtbar',
    'Verängstigt',
    'Vergiftet',
    'Versteinert',
  ];

  public notUsedConditions(): string[] {
    return this.conditionOptions.filter(
      (condition) => !this.conditions.includes(condition)
    );
  }

  public addCondition(): void {
    this.conditions.push(this.currentCondition);
  }

  public removeCondition(index: number): void {
    this.conditions.splice(index, 1);
  }

  public close(result: string): void {
    if (result === 'update') {
      this.detailsAccessor.closePanel(result, this.conditions);
    } else if (result === 'dismiss') {
      this.detailsAccessor.closePanel({ state: result });
    }
  }
}
