import { Component } from '@angular/core';
import { DataService } from 'src/services/data/data.service';
import { DetailsService } from 'src/services/details/details.service';
import { StatusDetailsComponent } from './status-details/status-details.component';

@Component({
  selector: 'status',
  templateUrl: './status.component.html',
  styleUrl: './status.component.scss',
})
export class StatusComponent {
  public constructor(
    private dataAccessor: DataService,
    public detailsAccessor: DetailsService
  ) {}

  public exhaustion: number = 0;
  public conditions: string[] = ['Blind', 'Kampfunfähig', 'Betäubt'];

  public availableConditions: string[] = [
    'Betäubt',
    'Bewusstlos',
    'Bezaubert',
    'Blind',
    'Festgesetzt',
    'Gelähmt',
    'Gepackt',
    'Kampfunfähig',
    'Liegend',
    'Taub',
    'Unsichtbar',
    'Verängstigt',
    'Vergiftet',
    'Versteinert',
  ];

  public ngOnInit(): void {
    // this.conditions = this.dataAcessor.conditions()
    // this.exhaustion = this.dataAccessor.exhaustion();
  }

  public updateExhaustion(): void {
    // this.dataAccessor.exhaustion = this.exhaustion;
  }

  public updateCondition(): void {
    // this.dataAccessor.statuses = this.conditions;
  }

  public openDetailsPanel(): void {
    this.detailsAccessor.openPanel(StatusDetailsComponent, {
      conditions: JSON.parse(JSON.stringify(this.conditions)),
    });
    const resultSubscription = this.detailsAccessor.result$.subscribe(
      (result) => {
        console.log(result);
        if (result.state === 'update') {
          this.conditions = result.data;
        }
        resultSubscription.unsubscribe();
      }
    );
  }
}
